<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateMobileVoiceAccessReq StructType
 * @subpackage Structs
 */
class UpdateMobileVoiceAccessReq extends APIRequest
{
    /**
     * The pattern
     * Meta information extracted from the WSDL
     * - choice: uuid | pattern
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $pattern;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | pattern
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The newPattern
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newPattern;
    /**
     * The routePartitionName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $routePartitionName;
    /**
     * The removeLocales
     * Meta information extracted from the WSDL
     * - choice: removeLocales | addLocales | locales
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales
     */
    public $removeLocales;
    /**
     * The addLocales
     * Meta information extracted from the WSDL
     * - choice: removeLocales | addLocales | locales
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\AddLocales
     */
    public $addLocales;
    /**
     * The locales
     * Meta information extracted from the WSDL
     * - choice: removeLocales | addLocales | locales
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\Locales
     */
    public $locales;
    /**
     * Constructor method for UpdateMobileVoiceAccessReq
     * @uses UpdateMobileVoiceAccessReq::setPattern()
     * @uses UpdateMobileVoiceAccessReq::setUuid()
     * @uses UpdateMobileVoiceAccessReq::setNewPattern()
     * @uses UpdateMobileVoiceAccessReq::setRoutePartitionName()
     * @uses UpdateMobileVoiceAccessReq::setRemoveLocales()
     * @uses UpdateMobileVoiceAccessReq::setAddLocales()
     * @uses UpdateMobileVoiceAccessReq::setLocales()
     * @param string $pattern
     * @param string $uuid
     * @param string $newPattern
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales $removeLocales
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AddLocales $addLocales
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Locales $locales
     */
    public function __construct($pattern = null, $uuid = null, $newPattern = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName = null, \\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales $removeLocales = null, \\Losc\CucmBundle\Model\Webservice\StructType\AddLocales $addLocales = null, \\Losc\CucmBundle\Model\Webservice\StructType\Locales $locales = null)
    {
        $this
            ->setPattern($pattern)
            ->setUuid($uuid)
            ->setNewPattern($newPattern)
            ->setRoutePartitionName($routePartitionName)
            ->setRemoveLocales($removeLocales)
            ->setAddLocales($addLocales)
            ->setLocales($locales);
    }
    /**
     * Get pattern value
     * @return string
     */
    public function getPattern()
    {
        return isset($this->pattern) ? $this->pattern : null;
    }
    /**
     * Set pattern value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $pattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setPattern($pattern = null)
    {
        if (is_null($pattern) || (is_array($pattern) && empty($pattern))) {
            unset($this->pattern);
        } else {
            $this->pattern = $pattern;
        }
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setUuid($uuid = null)
    {
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get newPattern value
     * @return string|null
     */
    public function getNewPattern()
    {
        return $this->newPattern;
    }
    /**
     * Set newPattern value
     * @param string $newPattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setNewPattern($newPattern = null)
    {
        $this->newPattern = $newPattern;
        return $this;
    }
    /**
     * Get routePartitionName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getRoutePartitionName()
    {
        return isset($this->routePartitionName) ? $this->routePartitionName : null;
    }
    /**
     * Set routePartitionName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setRoutePartitionName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName = null)
    {
        if (is_null($routePartitionName) || (is_array($routePartitionName) && empty($routePartitionName))) {
            unset($this->routePartitionName);
        } else {
            $this->routePartitionName = $routePartitionName;
        }
        return $this;
    }
    /**
     * Get removeLocales value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales|null
     */
    public function getRemoveLocales()
    {
        return isset($this->removeLocales) ? $this->removeLocales : null;
    }
    /**
     * Set removeLocales value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales $removeLocales
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setRemoveLocales(\\Losc\CucmBundle\Model\Webservice\StructType\RemoveLocales $removeLocales = null)
    {
        if (is_null($removeLocales) || (is_array($removeLocales) && empty($removeLocales))) {
            unset($this->removeLocales);
        } else {
            $this->removeLocales = $removeLocales;
        }
        return $this;
    }
    /**
     * Get addLocales value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\AddLocales|null
     */
    public function getAddLocales()
    {
        return isset($this->addLocales) ? $this->addLocales : null;
    }
    /**
     * Set addLocales value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AddLocales $addLocales
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setAddLocales(\\Losc\CucmBundle\Model\Webservice\StructType\AddLocales $addLocales = null)
    {
        if (is_null($addLocales) || (is_array($addLocales) && empty($addLocales))) {
            unset($this->addLocales);
        } else {
            $this->addLocales = $addLocales;
        }
        return $this;
    }
    /**
     * Get locales value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\Locales|null
     */
    public function getLocales()
    {
        return isset($this->locales) ? $this->locales : null;
    }
    /**
     * Set locales value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Locales $locales
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateMobileVoiceAccessReq
     */
    public function setLocales(\\Losc\CucmBundle\Model\Webservice\StructType\Locales $locales = null)
    {
        if (is_null($locales) || (is_array($locales) && empty($locales))) {
            unset($this->locales);
        } else {
            $this->locales = $locales;
        }
        return $this;
    }
}
